
    .286
    .MODEL  small
    .STACK  100h
;__________________________________________________________________________
EXTRN  WriteCharLPT_21h     : NEAR
EXTRN  WriteCharLPT_17h     : NEAR
EXTRN  InitLPT_17h          : NEAR
EXTRN  ReadStatusLPT_17h    : NEAR
EXTRN  WriteCharLPT_Port    : NEAR
EXTRN  InitLPT_Port         : NEAR

;__________________________________________________________________________
    .DATA
    
; 祭 ⮢ status-
_Busy_  EQU     80h     ; Busy
_ACK_   EQU     40h     ; Acknowlegment
_PE_    EQU     20h     ; Paper End
_Sel_   EQU     10h     ; Select
_Err_   EQU     08h     ; Error


; 祭 ⮢ control-
_IRQ_     EQU     10h     ; IRQ Enable
_Sel_In_  EQU     08h     ; Select In
_Init_    EQU     04h     ; Initialize
_Auto_LF_ EQU     02h     ; Auto Line Feed
_Send_    EQU     01h     ; Send Strobe

BasePort  EQU     408h  ; 饭    LPT


    .CODE
_start:
    xor     ax, ax      ; 
    mov     es, ax      ;
    mov     dx, es:[BasePort]   ; ।塞  ॣ 
    mov     bx, dx
    inc     dx          ; 室  ᭮ 
    in      al, dx      ; ⠥   - 
    in      al, dx      ; ஭ ᨣ BUSY
    mov     ah, al
                        ; 㫨 ᯮ㥬 
    and     al, (_Busy_ + _ACK_ + _PE_ + _Sel_ + _Err_)
                        ; 㥬 䫠  㤮⢠
    xor     al, (_Busy_ + _ACK_ + _Err_)
    test    al, _Sel_   ; ஢ਬ  稥 訡
    jz      _quit_
    test    al, _Err_
    jz      _ready_
    jmp     _quit_
_ready_:
    mov     dx, bx      ; 樠㥬 ਭ
    call    InitLPT_Port
    mov     al, '*'     ;  ⠥ ᨬ
    mov     dx, bx
    call    WriteCharLPT_Port
_quit_:
    mov     ah, 4ch     ; 室
    int     21h
  

    END