

    .286
    .MODEL  small
    .CODE
    
PUBLIC  WriteCharLPT_21h
PUBLIC  WriteCharLPT_17h
PUBLIC  InitLPT_17h
PUBLIC  ReadStatusLPT_17h
PUBLIC  WriteCharLPT_Port
PUBLIC  InitLPT_Port

;__________________________________________________________________________
;----------------- 뢠 21h 㭪 5h ------------------------------
;__________________________________________________________________________

;
; 뫠 ᨬ  DL  ⠭⭮ ன⢮ ਭ, 筮 LPT1.
; 室:
; DL - ᨬ, 뢠  ⠭ ਭ
;
WriteCharLPT_21h    PROC
    push    ax
    mov     ah, 05h
    int     21h
    pop     ax
    ret
WriteCharLPT_21h    ENDP

;__________________________________________________________________________
;----------------------- 뢠 17h -----------------------------------
;__________________________________________________________________________

;
;  ᨬ
;  室: AL = ASCII ᨬ
;        DX =  ਭ (0,1  2)
; 室: AH = 01H ᫨ ᨬ  ⠭ (訡 ⠩)
;             㣨  -   㭪樨 02H (䫠 ﭨ)
;
WriteCharLPT_17h    PROC
    mov     ah, 0
    int     17h
    ret
WriteCharLPT_17h    ENDP

;__________________________________________________________________________
;
; 樠஢  ਭ
; 室: DX =  ਭ (0,1  2)
; 室: AH =   㭪樨 02H (䫠 ﭨ)
;
InitLPT_17h         PROC
    mov     ah, 1
    int     17h
    ret
InitLPT_17h         ENDP

;__________________________________________________________________________
;
;   ਭ
; 室: DX =  ਭ (0,1  2)
; 室: AH = 䫠 ﭨ ਭ
;       76543210
;                
;       ҽ
;             ˼  ⠩      (AH & 01H)
;               ( ᯮ)
;             訡 /   (AH & 08H)
;            ࠭       (AH & 10H) (00H 砥 䫠)
;            㬠   (AH & 20H)
;          ⢥ত(AH & 40H) (40H = ᮥ)
;               (AH & 80H) 0 - 砥 
;
ReadStatusLPT_17h   PROC
    mov     ah, 2
    int     17h
    ret
ReadStatusLPT_17h   ENDP


;__________________________________________________________________________
;----------------- ணࠬ஢ १  ---------------------------
;__________________________________________________________________________

; 祭 ⮢ status-
_Busy_  EQU     80h     ; Busy
_ACK_   EQU     40h     ; Acknowlegment
_PE_    EQU     20h     ; Paper End
_Sel_   EQU     10h     ; Select
_Err_   EQU     08h     ; Error


; 祭 ⮢ control-
_IRQ_     EQU     10h     ; IRQ Enable
_Sel_In_  EQU     08h     ; Select In
_Init_    EQU     04h     ; Initialize
_Auto_LF_ EQU     02h     ; Auto Line Feed
_Send_    EQU     01h     ; Send Strobe

Init_Delay  EQU 5000    ; 稪  প  樠樨 ਭ

;__________________________________________________________________________
;
; 뢮 ᨬ  饥 ன⢮
; 室: DX -   (378h, 278h, 3bah)
;       AL - ᨬ, 뫠   
;
WriteCharLPT_Port   PROC
    out     dx, al      ; 襬 ᨬ   
    inc     dx
    inc     dx          ; ३  ࠢ饬 
    mov     al,(_Sel_In_ + _Init_ + _Send_) ; ਧ । 
    out     dx, al      ; ⠭  ࠢ饬 
    and     al, not _Send_    ; ᨬ ᨣ strobe   
    jmp     short $+2
    jmp     short $+2
    out     dx, al      ; 訬 । 
    dec     dx          ;   
_not_ready:
    in      al, dx      ; ⠥ ﭨ
    xor     al, (_Busy_ + _ACK_ + _Err_)  ;    ਭ  ⠭ ᢮
    test    al, _Busy_
    jnz     _not_ready
    test    al, _Err_   ; ᫨ ந諠 訡, 멤  ਧ 訡
    jnz     _error      ; ᨬ CF ( । )
    clc
    ret
_error:
    stc                 ; ⠭ CF (।  訡)
    ret
WriteCharLPT_Port   ENDP                  

;__________________________________________________________________________
;
; 樠஢  ਭ
; 室: DX -   (378h, 278h, 3bah)
;
InitLPT_Port        PROC
    push    ax
    push    cx          ; ࠭塞  ⥪ 塞 ॣ
    inc     dx
    inc     dx          ; ३  ࠢ饬 
    mov     al, _Sel_In_  ; 뫠 ᨣ 롮ન ன⢠ ন  
    out     dx, al
    mov     cx, Init_Delay
_loop:
    loop    _loop       ; ( ⮣ 믮塞 ⮩ 横)
    mov     al, (_Sel_In_ + _Init_)
    out     dx, al      ; 稫 樠
    pop     cx
    pop     ax
    ret
InitLPT_Port        ENDP

;__________________________________________________________________________

    END